         TITLE 'VDM SCREEN SORT PROGRAM'
;******************************************************
;*                                                    *
;*      NEWETT AWL'S SCREEN SORT FOR THE SIGHT        *
;*                 OF YOUR LIFE                       *
;*                                                    *
;******************************************************
;
         ORG   0C990H
;
SORT:    CALL  PSCAN         ;GET SIZE
         SHLD  SIZE          ;STORE...
SRT1:    LHLD  SIZE          ;GET SIZE BACK...
         MOV   A,L           ;SEE IF SIZE IS ZERO
         ORA   H
         JZ    DONE          ;IF YES, LEAVE
CON1:    SHLD  COMPCT        ;SET UP COMPARISON POINT
         SHLD  ITMCNT        ;RESET ITEM COUNT
         LXI   B,0           ;CLEAR B & C
         LXI   H,TOP         ;POINT TO TOP OF AREA
         LXI   D,TOP + 1     ;POINT TO TOP + 1 OF AREA
CON2:    LDAX  D             ;GET ITEM B FROM AREA
         CMP   M             ;COMPARE TO ITEM A
         JNC   CON3          ;IF A < B
         MOV   C,M           ;ITEM A TO REGISTER C
         MOV   M,A           ;ITEM B TO WHERE ITEM A WAS
         MOV   A,C           ;PUT ITEM A WHERE ITEM B WAS
         STAX  D
         MOV   B,A           ;USE BYTE FOR SWAP FLAG
CON3:    INX   H             ;INCREMENT ITEM A POINTER
         INX   D             ;INCREMENT ITEM B POINTER
         PUSH  H             ;KEEP MEMORY REFERENCE
         LHLD  ITMCNT        ;RESTORE ITEM COUNT
         DCX   H             ;DECREMENT IT
         SHLD  ITMCN         ;RESTORE IT
         MOV   A,L           ;TEST IF
         ORA   H             ;...ITEM COUNT IS ZERO
         POP   H             ;GET MEMORY REFERENCE BACK
         JNZ   CON2          ;NO, GO DO MORE
         XRA   A             ;CLEAR FLAGS
         ADD   B             ;GET SWAP FLAG
         LHLD  COMPCT        ;GET NEW ITEM COUNT
         DCX   H             ;REDUCE COMPARE COUNT BY 1
         JNZ   CON1          ;IF IT DID SWAP
DONE:    RET
;
;  WORKING STORAGE AREA
;
ITMCNT:  DW    0             ;INNER ITEM COUNT
COMPCT:  DW    0             ;NO. OF ITEMS IN THE LIST
SIZE:    DW    1023          ;ARBITRARY LENGTH
TOP      EQU   0CC00H        ;USE SCREEN FOR AREA OF SORT
PSCAN    EQU   0C310H        ;PSCAN IN SOLOS
         END
