         TITLE 'BINDUMP - BINARY DUMP OF MEMORY TO SERIAL PORT & VDM'
         ORG   0C900H
;
;  THESE LINES GET THE ADDRESSES ...
;
BDMP:    CALL  SCONV         ;SCAN TO FIRST ADR & CONVERT IT
         PUSH  H             ;SAVE THE VALUE
         CALL  PSCAN         ;SEE IF SECOND PARAMETER WAS GIVEN
         POP   D             ;GET BACK START
         XCHG                ;HL=START, DE=END
;
;   THIS LOOP PUTS IT ALL OUT ...
;
LP:      MOV   B,M           ;GET BYTE
         CALL  SDROT         ;SEND IT TO TELEX VIA SERIAL PORT
         PUSH  H             ;GOTTA SAVE EVERYBODY...
         PUSH  D             ;JUST FOR SAFETY'S SAKE
         PUSH  B
         CALL  OCHAR         ;SEND TO SCREEN TOO...
         POP   B             ;RESTORE REGISTERS
         POP   D
         POP   H
         MOV   A,L           ;COMPARE D&E TO H&L
         SUB   E
         MOV   A,H
         SBB   D
         RNC
         INX   H
         CALL  KSTAT
         JZ    LP
         CPI   MODE
         RZ
         JMP   LP
;
;   EQUIVALENCES ..
;
SCONV    EQU   0C33AH
PSCAN    EQU   0C310H
SDROT    EQU   0C04AH
OCHAR    EQU   0C098H
KSTAT    EQU   0C02EH
MODE     EQU   80H
         END
