         TITLE 'SOL CASSETTE TEST ROUTINES'
         ORG   0C900H
;
;  THIS ROUTINE WRITES OUT A TEST PATTERN TO THE TAPE
;  CONTINUOUSLY. THE SOL MUST BE RESET BEFORE CONTINUING.
;
CT1:     IN    TAPPT
         CPI   TTBE
         JZ    CT1
         INR   C
         MOV   A,C
         OUT   TDATA
         JMP   CT1
;
;  THIS ROUTINE READS BACK THE TEST PATTERN BACK FROM THE
;  TAPE AND DISPLAYS IT ON THE SCREEN.
;
CT2:     IN    TAPPT
         CPI   TDR
         JZ    CT2
         IN    TDATA
         SBI   0FFH
         JNZ   CT2
CT2B:    LXI   H,VDMEM + 200H
CT3:     IN    TAPPT
         CPI   TDR
         JZ    CT3
         IN    TDATA
         MOV   M,A
         INR   L
         MOV   A,L
         SBI   00H
         JNZ   CT3
         MVI   A,(VDMEM + 300H) SHR 8
CT4:     IN    TAPPT
         CPI   TDR
         JZ    CT4
         IN    TDATA
         MOV   M,A
         INR   L
         MOV   A,L
         SBI   80H
         JNZ   CT4
         JMP   CT2B
;
;  SOL CASSETTE I/O PORT EQUIVALENCES
;
TAPPT    EQU   0FAH
TDATA    EQU   0FBH
TTBE     EQU   80H
TDR      EQU   40H
;
VDMEM    EQU   0CC00H        ;SOLOS VIDEO DISPLAY MEMORY
;
         END
