         TITLE 'PRETTY SHORT LOADER  -  VER. 1.0'
         ORG   0C8B0H
PSL:     MVI   B,0DH                   ;ASCII <CR>
         CALL  SDROT                   ;AND TO SERIAL PORT
RED0:    CALL  MIN                     ;GET A CHAR FROM MODEM
         CPI   ':'
         JNZ   RED0                    ;LOOKING FOR A ':' RECORD MARK
         CALL  BYTE
         RZ                            ;EXIT ON ZERO BLOCK LENGTH TO SOLOS
         MOV   E,A                     ;BLOCK LENGTH STORED IN E
         CALL  BYTE
         MOV   H,A
         CALL  BYTE
         MOV   L,A                     ;H & L NOV HAVE STARTING ADDRESS
         CALL  BYTE                    ;READ & IGNORE RECORD TYPE BYTE
RED1:    CALL  BYTE                    ;READ DATA & CHECKSUM INFO
         MOV   M,A                     ;STORE DATA IN SOL MEMORY
         INX   H                       ;BUMP MEMORY ADDRESS
         DCR   E                       ;DECREMENT BLOCK LENGTH COUNT
         JNZ   RED1                    ;LOOP IF NOT END OF BLOCK
         JMP   RED0                    ;READ NEXT BLOCK
BYTE:    CALL  INHEX                    ;GET AN ASCII HEX CHAR
         RLC
         RAL
         RAL
         RAL                           ;SHIFT TO BOTTOM OF ACCUMULATOR
         MOV   C,A                     ;STORE IN REG C
LUP:     CALL  INHEX                   ;GET AN ASCII HEX CHAR
         ADD   C
         RET
MIN:     CALL  SSTAT                   ;GET A CHAR FROM MODEM
         JZ    MIN                     ;LOOP UNTIL AVAILABLE
         RET
INHEX:   CALL  MIN                     ;GET A CHAR
         CALL  HCOV1                   ;CONVERT TO BINARY
         CPI   10H                     ;LEGAL VALUE ?
         RC                            ;RETURN IF SO
EM:      JMP   0C466H
;
COMN1    EQU   0C1C0H                  ;COMMAND MODE RE-ENTRY POINT
SDROT    EQU   0C04AH                  ;NECESSARY SOLOS JUMP
SSTAT    EQU   0C042H                  ;TABLE EQUIVALENCES
VDMOT    EQU   0C054H
HCOV1    EQU   0C35DH
         END
